;
;Assembly language routines to quickly set EGA palette register(s)
;

	DOSSEG

	.MODEL	MEDIUM,BASIC

	.DATA

	.CODE


	PUBLIC	EGAPal

EGAPal		PROC	PalReg: WORD, PalColor: WORD

	MOV	BX,PalReg	;Get palette register number
	MOV	AX,PalColor	;Get palette register color
	MOV	BH,AL		; ..
	CALL	SetPalette	;Set the palette register
	RET

EGAPal		ENDP


	PUBLIC	EGAPalUsing

EGAPalUsing	PROC	Palette: DWORD

	LES	DI,Palette	;Get address of palette array
	MOV	DX,3DAH		;Address & status register
	MOV	CX,16		;Do 16 palette registers
	MOV	BL,0		;Initialize palette register number counter
EGAPalUsing1:
	MOV	BH,ES:[DI]	;Get palette register color
	CALL	SetPalette	; ..
	INC	BL		;Bump up register number
	INC	DI		;Point to next palette entry
	INC	DI		; ..
	LOOP	EGAPalUsing1	;Do next palette entry
	RET

EGAPalUsing	ENDP


SetPalette	PROC	NEAR

	AND	BX,3F0FH	;Validate palette register number and color
	MOV	DX,3DAH		;Address & status register
	CLI			;Disable interrupts
SetPalette1:
	IN	AL,DX		;Wait for vertical retrace
	TEST	AL,8		; ..
	JZ	SetPalette1	; ..
	MOV	DL,0C0H		;Update palette register
	MOV	AL,BL		; ..
	OUT	DX,AL		; ..
	MOV	AL,BH		; ..
	OUT	DX,AL		; ..
	MOV	DL,0DAH		;Reset flip-flop
	IN	AL,DX		; ..
	MOV	DL,0C0H		;Set bit 5 of Attribute Controller Address reg
	MOV	AL,20H		; ..
	OUT	DX,AL		; ..
	STI			;Re-enable interrupts
	RET

SetPalette	ENDP

	END
